/*----------------------------------------------------------
	DirectX9HvO~O
		DirectX GraphicsTv

	DXGSample07.cpp
		uXt@C̓ǂݍ݁v

	(C) 2003 NARITA, Takuro
		E-Mail	narita@a1.mbn.or.jp
--------------------------------------------------------------*/

#define STRICT					// ^`FbNɍsȂ
//#define WIN32_LEAN_AND_MEAN	// wb_[炠܂gȂ֐Ȃ
#define WINVER	0x040A			// Windows 98 & Windows 2000ȍ~

#include <windows.h>
#include <tchar.h>
#include <d3dx9.h>
#include <dxerr9.h>

#include "SelectDevice.h"
#include "resource.h"

#define RELEASE(x)	if(x){x->Release();x=NULL;}

/*-------------------------------------------
	O[oϐ(AvP[V֘A)
--------------------------------------------*/
HINSTANCE	g_hInstance		= NULL;	// CX^XEnh
HWND		g_hWindow		= NULL;	// EChEEnh
HMENU		g_hMenu			= NULL;	// j[Enh

TCHAR		g_szAppTitle[]	= _T("DirectX 9.0 Graphics Sample07");
TCHAR		g_szWndClass[]	= _T("DX9GS07");

RECT		g_rectWindow;			// EChEE[hł̍Ō̈ʒu

// AvP[V̓tO
bool		g_bActive		= false;	// ANeBu

/*-------------------------------------------
	O[oϐ(foCX̐ݒ֘A)
--------------------------------------------*/
// N̉ʃ[h
bool		g_bWindow = true;

// ]ʃTCY(EChE)
SIZE		g_sizeWindowMode	= { 640, 480 };
// ]ʃTCY(tXN[)
SIZE		g_sizeFullMode	= { 1024, 768 };

// ]fBXvCEtH[}bg
D3DFORMAT	g_fmtDisplay[] =	{	D3DFMT_X8R8G8B8, D3DFMT_X1R5G5B5, D3DFMT_R5G6B5 };
int			g_fmtDisplayNum = sizeof(g_fmtDisplay) / sizeof(g_fmtDisplay[0]);
// ]郌_OEeNX`̃tH[}bg
D3DFORMAT	g_fmtRendTexter[] =	{	D3DFMT_X8R8G8B8, D3DFMT_X1R5G5B5, D3DFMT_R5G6B5 };
int			g_fmtRendTexterNum = sizeof(g_fmtRendTexter) / sizeof(g_fmtRendTexter[0]);
// ][x/XeVobt@̃tH[}bg(D3DFMT_UNKNOWNŖgp)
D3DFORMAT	g_fmtDepthStencil = D3DFMT_D24S8;
// ]}`ETvÕ^Cv
//D3DMULTISAMPLE_TYPE g_MultiSampleType[] =	{ D3DMULTISAMPLE_4_SAMPLES, D3DMULTISAMPLE_NONMASKABLE, D3DMULTISAMPLE_NONE	};
D3DMULTISAMPLE_TYPE g_MultiSampleType[] =	{ D3DMULTISAMPLE_NONE };
int					g_MultiSampleTypeNum = sizeof(g_MultiSampleType) / sizeof(g_MultiSampleType[0]);
// ]Present̎s[g
UINT		g_Interval = D3DPRESENT_INTERVAL_IMMEDIATE;

/*-------------------------------------------
	O[oϐ(DirectX֘A)
--------------------------------------------*/
bool g_bD3DEmpty = true;						// tO

// C^[tFCX
LPDIRECT3D9				g_pD3D			= NULL; // Direct3DC^[tFCX
LPDIRECT3DDEVICE9		g_pD3DDevice	= NULL; // Direct3DDeviceC^[tFCX
D3DPRESENT_PARAMETERS	g_D3DPP;				// D3DDevice̐ݒ()

D3DPRESENT_PARAMETERS	g_D3DPPWindow;			// D3DDevice̐ݒ(EChEE[hp)
D3DPRESENT_PARAMETERS	g_D3DPPFull;			// D3DDevice̐ݒ(tXN[E[hp)

D3DFORMAT				g_fmtRendTexterWindow;	// _OEeNX`̃tH[}bg(EChEp)
D3DFORMAT				g_fmtRendTexterFull;	// _OEeNX`̃tH[}bg(tXN[p)

// VF[_
LPDIRECT3DVERTEXSHADER9	g_pVertexShader = NULL;	// _VF[_󂯎ϐ
LPDIRECT3DPIXELSHADER9	g_pPixelShader1 = NULL;	// sNZEVF[_1(eNX`)
LPDIRECT3DPIXELSHADER9	g_pPixelShader2 = NULL;	// sNZEVF[_2(eNX`Ȃ)

bool g_bDeviceLost = false;						// foCX̏tO

// Xt@C̃bV
LPD3DXMESH				g_pD3DXMesh = NULL;		// bṼC^[tFCX
DWORD					g_dwNumMaterials = 0;	// }eȂ
D3DCOLORVALUE*			g_pMeshColor = NULL;
LPDIRECT3DTEXTURE9*		g_pMeshTexture = NULL;

D3DXVECTOR3				g_BSCenter(0.0f,0.0f,0.0f);	// E̒SW
FLOAT					g_BSRadius = 1.0f;			// E̔a

/*-------------------------------------------
	֐`
--------------------------------------------*/

LRESULT CALLBACK MainWndProc(HWND hWnd,UINT msg,UINT wParam,LONG lParam);

/*-------------------------------------------
	AvP[ViŏɈxĂ΂j
--------------------------------------------*/
HRESULT InitApp(HINSTANCE hInst)
{
	// AvP[ṼCX^XEnhۑ
	g_hInstance = hInst;

	// IME֎~
	ImmDisableIME(-1);

	// EChEENX̓o^
	WNDCLASSEX wcex;
	wcex.cbSize = sizeof(WNDCLASSEX);
	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)MainWndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInst;
	wcex.hIcon			= LoadIcon(hInst, (LPCTSTR)IDI_ICON1);
	wcex.hIconSm		= (HICON)LoadImage(hInst, (LPCTSTR)IDI_ICON1, IMAGE_ICON,
									16, 16, LR_DEFAULTCOLOR);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= g_bWindow ? MAKEINTRESOURCE(IDR_MENU1) : NULL;
	wcex.lpszClassName	= g_szWndClass;

	if (!RegisterClassEx(&wcex))
		return DXTRACE_ERR("InitApp", GetLastError());

	// CEEChE쐬
	g_rectWindow.top	= 0;
	g_rectWindow.left	= 0;
	g_rectWindow.right	= g_sizeWindowMode.cx;
	g_rectWindow.bottom	= g_sizeWindowMode.cy;
	AdjustWindowRect(&g_rectWindow, WS_OVERLAPPEDWINDOW, TRUE);
	g_rectWindow.right	= g_rectWindow.right - g_rectWindow.left;
	g_rectWindow.bottom	= g_rectWindow.bottom - g_rectWindow.top;
	g_rectWindow.top	= 0;
	g_rectWindow.left	= 0;

	RECT rect;
	if (g_bWindow)
	{
		// (EChEE[hp)
		rect.top	= CW_USEDEFAULT;
		rect.left	= CW_USEDEFAULT;
		rect.right	= g_rectWindow.right;
		rect.bottom	= g_rectWindow.bottom;
	}
	else
	{
		// (tXN[E[hp)
		rect.top	= 0;
		rect.left	= 0;
		rect.right	= g_sizeFullMode.cx;
		rect.bottom	= g_sizeFullMode.cy;

		g_hMenu = LoadMenu(g_hInstance, MAKEINTRESOURCE(IDR_MENU1));
	}

	g_hWindow = CreateWindow(g_szWndClass, g_szAppTitle,
		g_bWindow ? WS_OVERLAPPEDWINDOW : WS_POPUP,
			rect.left, rect.top, rect.right, rect.bottom,
			NULL, NULL, hInst, NULL);
	if (g_hWindow == NULL)
		return DXTRACE_ERR("InitApp", GetLastError());

	// EChE\
	ShowWindow(g_hWindow, SW_SHOWNORMAL);
	UpdateWindow(g_hWindow);

	return S_OK;
}

/*-------------------------------------------
	DirectX Graphics
--------------------------------------------*/
HRESULT InitDXGraphics(void)
{
	// Direct3DIuWFNg̍쐬
	g_pD3D = Direct3DCreate9(D3D_SDK_VERSION);
	if (g_pD3D == NULL)
		return DXTRACE_ERR("InitDXGraphics Direct3DCreate9", E_FAIL);

	// foCXݒ̑I
	UINT Adapter;
	D3DDEVTYPE Device;
	HRESULT hr = SelectD3DDevice(Adapter, Device);
	if (FAILED(hr))
		return DXTRACE_ERR("InitDXGraphics SelectD3DDevice", hr);

	// D3DDeviceIuWFNg̍쐬
	if (g_bWindow)
		g_D3DPP = g_D3DPPWindow;
	else
		g_D3DPP = g_D3DPPFull;

	hr = g_pD3D->CreateDevice(Adapter, Device, g_hWindow,
						D3DCREATE_HARDWARE_VERTEXPROCESSING, &g_D3DPP, &g_pD3DDevice);
	if (FAILED(hr))
	{
		hr = g_pD3D->CreateDevice(Adapter, Device, g_hWindow,
						D3DCREATE_SOFTWARE_VERTEXPROCESSING, &g_D3DPP, &g_pD3DDevice);
		if (FAILED(hr))
			return DXTRACE_ERR("InitDXGraphics CreateDevice", hr);
	}

	// r[|[g̐ݒ
	D3DVIEWPORT9 vp;
	vp.X		= 0;
	vp.Y		= 0;
	vp.Width	= g_D3DPP.BackBufferWidth;
	vp.Height	= g_D3DPP.BackBufferHeight;
	vp.MinZ		= 0.0f;
	vp.MaxZ		= 1.0f;
	hr = g_pD3DDevice->SetViewport(&vp);
	if (FAILED(hr))
		return DXTRACE_ERR("InitDXGraphics SetViewport", hr);

	// _VF[_̃AZu
	LPD3DXBUFFER pCode;
	hr = D3DXAssembleShaderFromFile(_T("DXGSample07.vs"), NULL, NULL, 0, &pCode, NULL);
	if (FAILED(hr))
		return DXTRACE_ERR("InitDXGraphics D3DXAssembleShaderFromFile DXGSample07.vs", hr);   // G[
	// _VF[_
	hr = g_pD3DDevice->CreateVertexShader((DWORD*)pCode->GetBufferPointer(), &g_pVertexShader);
	RELEASE(pCode);
	if (FAILED(hr))
		return DXTRACE_ERR("InitDXGraphics CreateVertexShader", hr);  // G[

	// sNZEVF[_1̃AZu
	hr = D3DXAssembleShaderFromFile(_T("DXGSample07_1.ps"), NULL, NULL, 0, &pCode, NULL);
	if (FAILED(hr))
		return DXTRACE_ERR("InitDXGraphics D3DXAssembleShaderFromFile DXGSample07_1.ps", hr);   // G[
	// sNZEVF[_1
	hr =g_pD3DDevice->CreatePixelShader((DWORD*)pCode->GetBufferPointer(), &g_pPixelShader1);
	RELEASE(pCode);
	if (FAILED(hr))
		return DXTRACE_ERR("InitDXGraphics CreatePixelShader", hr);  // G[

	// sNZEVF[_2̃AZu
	hr = D3DXAssembleShaderFromFile( _T("DXGSample07_2.ps"), NULL, NULL, 0, &pCode, NULL );
	if (FAILED(hr))
		return DXTRACE_ERR("InitDXGraphics D3DXAssembleShaderFromFile DXGSample07_2.ps", hr);   // G[
	// sNZEVF[_2
	hr =g_pD3DDevice->CreatePixelShader((DWORD*)pCode->GetBufferPointer(), &g_pPixelShader2);
	RELEASE(pCode);
	if (FAILED(hr))
		return DXTRACE_ERR("InitDXGraphics CreatePixelShader", hr);  // G[

	return S_OK;
}

/*-------------------------------------------
	XFile̓ǂݍ
--------------------------------------------*/
HRESULT LoadXFile(void)
{
	HRESULT hr;

	// \Xt@CI
	CHAR strPath[MAX_PATH];
	DWORD i = GetCurrentDirectory(MAX_PATH, strPath);
	if (i==0 || MAX_PATH<i)
		return S_OK;

	CHAR file_name[MAX_PATH] = TEXT("");
	OPENFILENAME ofn = { sizeof(OPENFILENAME), g_hWindow, NULL,
			TEXT("Xt@C\0*.x\0All Files\0*.*\0\0"),
			NULL, 0, 1, file_name, MAX_PATH, NULL, 0, strPath,
			TEXT("Xt@CJ"),
			OFN_FILEMUSTEXIST | OFN_HIDEREADONLY, 0, 0,
			TEXT(".x"), 0, NULL, NULL };
	if (TRUE != GetOpenFileName(&ofn))
		return S_OK;

	// f[^̊J
	for (i=0; i<g_dwNumMaterials; i++)
		RELEASE(g_pMeshTexture[i]);		// e}eÃeNX`J
	delete[] g_pMeshColor;				// }eÃfBt[YFJ
	delete[] g_pMeshTexture;			// }eÃeNX`pJ
	RELEASE(g_pD3DXMesh);				// bVJ
	g_dwNumMaterials = 0;

	// Xt@C̓ǂݍ
	LPD3DXBUFFER pD3DXMtrlBuffer;		// }eA󂯎ϐ
	hr = D3DXLoadMeshFromX(file_name,	// ǂݍXt@C
			D3DXMESH_SYSTEMMEM,			// _/CfbNXEobt@VXeEɍ
			g_pD3DDevice,				// bV̕`ɎgfoCX
			NULL,						// 
			&pD3DXMtrlBuffer,			// Xt@C̃}eA󂯎
			NULL,						// 
			&g_dwNumMaterials,			// }eA̐
			&g_pD3DXMesh);				// bV󂯎
	if (FAILED(hr))
		return DXTRACE_ERR("LoadXFile D3DXLoadMeshFromX", hr); // G[

	// }eAۑpz̊m
	g_pMeshColor   = new D3DCOLORVALUE[g_dwNumMaterials];
	g_pMeshTexture = new LPDIRECT3DTEXTURE9[g_dwNumMaterials];

	// }eAobt@̃|C^擾
	D3DXMATERIAL* d3dxMaterials = (D3DXMATERIAL*)pD3DXMtrlBuffer->GetBufferPointer();

	// e}eAۑ
	for (i=0; i<g_dwNumMaterials; i++)
	{
		// bV̐F
		g_pMeshColor[i] = d3dxMaterials[i].MatD3D.Diffuse;
		// eNX`̓ǂݍ
		HRESULT hr = D3DXCreateTextureFromFile(g_pD3DDevice,
						d3dxMaterials[i].pTextureFilename, &g_pMeshTexture[i]);
		if (FAILED(hr))
			g_pMeshTexture[i] = NULL; // eNX`Ȃ
	}

	// Xt@Cǂݍ񂾃}eÃobt@J
	RELEASE(pD3DXMtrlBuffer);

	// VbV̒_vf
	D3DVERTEXELEMENT9 decl[] = 
	{
		{ 0,  0, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_POSITION, 0 },	// _W
		{ 0, 12, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_NORMAL,   0 },	// @xNg
		{ 0, 24, D3DDECLTYPE_FLOAT2, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_TEXCOORD, 0 },	// eNX`W(2D)
		D3DDECL_END()   // z̏I
	};

	LPD3DXMESH pNewMesh;    // VbV󂯎ϐ

	// mɖ@xNgAVbV̍쐬
	hr = g_pD3DXMesh->CloneMesh(D3DXMESH_MANAGED, decl, g_pD3DDevice, &pNewMesh);
	if (FAILED(hr))
		return DXTRACE_ERR("LoadXFile CloneMesh", hr);

	RELEASE(g_pD3DXMesh);
	g_pD3DXMesh = pNewMesh;

	// e_̖@xNgvZ
	hr = D3DXComputeNormals(g_pD3DXMesh, NULL);
	if (FAILED(hr))
		return DXTRACE_ERR("LoadXFile D3DXComputeNormals", hr); // G[

	// EvZ
	// bV̒_obt@bN
	LPVOID pBuffer;
	g_pD3DXMesh->LockVertexBuffer(D3DLOCK_READONLY, &pBuffer);

	// bV̋E߂
	D3DXComputeBoundingSphere((LPD3DXVECTOR3)pBuffer,
			g_pD3DXMesh->GetNumVertices(),			// bV̒_
			g_pD3DXMesh->GetNumBytesPerVertex(),	// bV̒_f[^̑傫
			&g_BSCenter, &g_BSRadius);

	// bN_obt@AbN
	g_pD3DXMesh->UnlockVertexBuffer();

	return S_OK;
}

/*-------------------------------------------
	D3DɊǗȂIuWFNg̏Ȃ
--------------------------------------------*/
HRESULT InitD3DObject(void)
{
	// _OEXe[g̐ݒ
	// Zobt@̐ݒ
	g_pD3DDevice->SetRenderState(D3DRS_ZENABLE,
		g_D3DPP.EnableAutoDepthStencil ? D3DZB_TRUE : D3DZB_FALSE);

	// }`TvO̐ݒ
	g_pD3DDevice->SetRenderState(D3DRS_MULTISAMPLEANTIALIAS,
		g_D3DPP.MultiSampleType != D3DMULTISAMPLE_NONE ? TRUE : FALSE);

	// O[[EVF[fBOɐݒ
	g_pD3DDevice->SetRenderState(D3DRS_SHADEMODE, D3DSHADE_GOURAUD);

	// JO
	g_pD3DDevice->SetRenderState(D3DRS_CULLMODE, D3DCULL_CCW);  // wʂJO

	return S_OK;
}

/*--------------------------------------------
	ʂ̕`揈
--------------------------------------------*/
HRESULT Render(void)
{
	// V[̃NA
	DWORD Flags = (g_D3DPP.EnableAutoDepthStencil == TRUE) ?
		D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER | D3DCLEAR_STENCIL : D3DCLEAR_TARGET;
	g_pD3DDevice->Clear(0, NULL, Flags, D3DCOLOR_XRGB(0, 0, 255), 1.0f, 0);

	// V[̕`Jn
	if (SUCCEEDED(g_pD3DDevice->BeginScene()))
	{
		// V[̕`
		D3DXMATRIX matT, matS, matR;
		D3DXMATRIX matWorld;									// [hϊs
		D3DXMatrixTranslation(&matT,
				-g_BSCenter.x, -g_BSCenter.y, -g_BSCenter.z);	// f̒S_Ɉړ
		FLOAT s = 1.0f/g_BSRadius;
		D3DXMatrixScaling(&matS, s, s, s);						// f̑傫1ɂ
		FLOAT ry = (GetTickCount() % 3000) * 6.283f / 3000.0f;
		D3DXMatrixRotationY(&matR, ry);							// Y𒆐Sɉ](3b1])
		matWorld = matT * matS * matR;

		D3DXMATRIX matView;									// r[ϊs
		D3DXVECTOR3 vEye(0.0f, 1.2f, -2.4f);				// J̍W
		D3DXVECTOR3 vAt(0.0f, 0.0f, 0.0f);					// _
		D3DXVECTOR3 vUp(0.0f, 2.0f, 1.0f);					// J̏xNg
		D3DXMatrixLookAtLH(&matView, &vEye, &vAt, &vUp);	// r[ϊs

		D3DXMATRIX matProj;						// ϊs
		D3DXMatrixPerspectiveFovLH(&matProj,
				3.1415f/4.0f,					// p45x
				(float)g_D3DPP.BackBufferWidth/(float)g_D3DPP.BackBufferHeight,	// AXyNg
				1.0f,				// Oeʂ܂ł̋
				5.0f);				// eʂ܂ł̋

		D3DXMATRIX mat = matWorld * matView * matProj;		// Ŝ̕ϊs
		D3DXMatrixTranspose(&mat, &mat);
		g_pD3DDevice->SetVertexShaderConstantF(0, (float*)&mat, 4);	// c0`c3WX^ɐݒ

		// CgBuc4vWX^̐ݒ
		D3DXVECTOR4 vLight(1.0f, 1.0f, -1.0f, 0.0f);	// [hWnł̃Cg̕ݒ肵Ă
		D3DXMatrixInverse(&mat, NULL, &matWorld);		// [hϊs̋ts߂
		D3DXVec4Transform(&vLight, &vLight, &mat);		// Cg̕fWnɕϊ
		D3DXVec4Normalize(&vLight, &vLight);
		g_pD3DDevice->SetVertexShaderConstantF(4, (float*)&vLight, 1);	// c4

		// _VF[_̓o^
		g_pD3DDevice->SetVertexShader(g_pVertexShader);

		// bV̕`P(eNX`̂郁bV)

		// sNZEVF[_̓o^
		g_pD3DDevice->SetPixelShader(g_pPixelShader1);
		// eNX`̂郁bV}eAʂɕ`
		for (DWORD i=0; i<g_dwNumMaterials; i++)
		{
			if (g_pMeshTexture[i] == NULL)
				continue;
			// c5WX^ɁAfBt[YFݒ
			g_pD3DDevice->SetVertexShaderConstantF(5, (float*)(g_pMeshColor + i), 1);
			// eNX`EXe[W0ɃeNX`ݒ
			g_pD3DDevice->SetTexture(0, g_pMeshTexture[i]);
			// }eA`
			g_pD3DXMesh->DrawSubset(i);
		}

		// bV̕`Q(eNX`̂ȂbV)

		// sNZEVF[_̓o^
		g_pD3DDevice->SetPixelShader(g_pPixelShader2);
		// eNX`EXe[W0̃eNX`ݒ
		g_pD3DDevice->SetTexture(0, NULL);
		// eNX`̂ȂbV}eAʂɕ`
		for (/*DWORD */i=0; i<g_dwNumMaterials; i++)
		{
			if (g_pMeshTexture[i] != NULL)
				continue;
			// c5WX^ɁAfBt[YFݒ
			g_pD3DDevice->SetVertexShaderConstantF(5, (float*)(g_pMeshColor + i), 1);
			// }eA`
			g_pD3DXMesh->DrawSubset(i);
		}

		// V[̕`I
		g_pD3DDevice->EndScene();
	}

	// V[̕\
	return g_pD3DDevice->Present(NULL, NULL, NULL, NULL);
}

/*-------------------------------------------
	D3DɊǗȂIuWFNg̏I
--------------------------------------------*/
HRESULT CleanupD3DObject(void)
{
	return S_OK;
}

/*-------------------------------------------
	EChEETCY̕ύX
--------------------------------------------*/
HRESULT ChangeWindowSize(void)
{
	// EChẼNCAg̈ɍ킹
	CleanupD3DObject();

	HRESULT hr = g_pD3DDevice->Reset(&g_D3DPP);
	if (FAILED(hr))
	{
		if (hr == D3DERR_DEVICELOST)
			g_bDeviceLost = true;
		else
			DestroyWindow(g_hWindow);
		return DXTRACE_ERR("ChangeWindowSize Reset", hr);
	}
	hr = InitD3DObject();
	if (FAILED(hr))
	{
		DestroyWindow(g_hWindow);
		return DXTRACE_ERR("ChangeWindowSize InitD3DObject", hr);
	}

	// r[|[g̐ݒ
	D3DVIEWPORT9 vp;
	vp.X		= 0;
	vp.Y		= 0;
	vp.Width	= g_D3DPP.BackBufferWidth;
	vp.Height	= g_D3DPP.BackBufferHeight;
	vp.MinZ		= 0.0f;
	vp.MaxZ		= 1.0f;
	hr = g_pD3DDevice->SetViewport(&vp);
	if (FAILED(hr))
	{
		DXTRACE_ERR("ChangeWindowSize SetViewport", hr);
		DestroyWindow(g_hWindow);
	}
	return hr;
}

/*-------------------------------------------
	ʃ[h̕ύX
--------------------------------------------*/
void ChangeDisplayMode(void)
{
	g_bWindow = !g_bWindow;

	CleanupD3DObject();

	if (g_bWindow)
	{
		g_D3DPP = g_D3DPPWindow;
	}
	else
	{
		g_D3DPP = g_D3DPPFull;
		GetWindowRect(g_hWindow, &g_rectWindow);
	}

	HRESULT hr = g_pD3DDevice->Reset(&g_D3DPP);
	if (FAILED(hr))
	{
		if (hr == D3DERR_DEVICELOST)
			g_bDeviceLost = true;
		else
			DestroyWindow(g_hWindow);
		DXTRACE_ERR("ChangeDisplayMode Reset", hr);
		return;
	}

	hr = InitD3DObject();
	if (FAILED(hr))
	{
		DXTRACE_ERR("ChangeDisplayMode InitD3DObject", hr);
		DestroyWindow(g_hWindow);
		return;
	}

	if (g_bWindow)
	{
		SetWindowLong(g_hWindow, GWL_STYLE, WS_OVERLAPPEDWINDOW | WS_VISIBLE);
		if(g_hMenu != NULL)
		{
			SetMenu(g_hWindow, g_hMenu);
			g_hMenu = NULL;
		}
		SetWindowPos(g_hWindow, HWND_NOTOPMOST,
				g_rectWindow.left, g_rectWindow.top,
				g_rectWindow.right - g_rectWindow.left,
				g_rectWindow.bottom - g_rectWindow.top,
				SWP_SHOWWINDOW);
	}
	else
	{
		SetWindowLong(g_hWindow, GWL_STYLE, WS_POPUP | WS_VISIBLE);
		if(g_hMenu == NULL)
		{
			g_hMenu = GetMenu(g_hWindow);
			SetMenu(g_hWindow, NULL);
		}
	}
}

/*-------------------------------------------
	DirectX Graphics̏I(ɎsƂĂ΂)
--------------------------------------------*/
bool CleanupDXGraphics(void)
{
	// 擾IuWFNg̊J
	for (DWORD i=0; i<g_dwNumMaterials; i++)
		RELEASE(g_pMeshTexture[i]);		// e}eÃeNX`J
	delete[] g_pMeshColor;				// }eÃfBt[YFJ
	delete[] g_pMeshTexture;			// }eÃeNX`pJ
	RELEASE(g_pD3DXMesh);				// bVJ

	RELEASE(g_pPixelShader2);
	RELEASE(g_pPixelShader1);
	RELEASE(g_pVertexShader);

	RELEASE(g_pD3DDevice);
	RELEASE(g_pD3D);

	return true;
}

/*-------------------------------------------
	AvP[V̏IiŌɌĂ΂j
--------------------------------------------*/
bool CleanupApp(void)
{
	// j[Enh̍폜
	if (g_hMenu)
		DestroyMenu(g_hMenu);
	
	// EChEENX̓o^
	UnregisterClass(g_szWndClass, g_hInstance);
	return true;
}

/*-------------------------------------------
	EBhE
--------------------------------------------*/
LRESULT CALLBACK MainWndProc(HWND hWnd, UINT msg, UINT wParam, LONG lParam)
{
	HRESULT hr = S_OK;

	switch(msg)
	{
	case WM_ACTIVATE:
		g_bActive = (LOWORD(wParam) != 0);
		break;

	case WM_DESTROY:
		// D3DɊǗȂIuWFNg̏I
		CleanupD3DObject();
		// DirectX Graphics̏I
		CleanupDXGraphics();
		// EChE
		PostQuitMessage(0);
		g_hWindow = NULL;
		return 0;

	// EChEETCY̕ύX
	case WM_SIZE:
		if (g_D3DPP.Windowed != TRUE)
			break;

		if (!g_pD3DDevice || wParam == SIZE_MINIMIZED)
			break;
		g_D3DPP.BackBufferWidth  = LOWORD(lParam);
		g_D3DPP.BackBufferHeight = HIWORD(lParam);
		if(g_bDeviceLost)
			break;
		if (wParam == SIZE_MAXIMIZED || wParam == SIZE_RESTORED)
			ChangeWindowSize();
		break;

	case WM_SETCURSOR:
		if (g_D3DPP.Windowed != TRUE)
		{
			SetCursor(NULL);
			return 1;
		}
		break;

	case WM_KEYDOWN:
		// L[͂̏
		switch(wParam)
		{
		case VK_ESCAPE:	// [ESCAPE]L[ŃEChE
			PostMessage(hWnd, WM_CLOSE, 0, 0);
			break;

		case 'W':	// ʃ[h̐؂ւ
			ChangeDisplayMode();
			break;

		case 'F':	// tbgEVF[fBOɐ؂ւ
			if (g_pD3DDevice)
				g_pD3DDevice->SetRenderState(D3DRS_SHADEMODE, D3DSHADE_FLAT);
			break;

		case 'G':	// O[[EVF[fBOɐ؂ւ
			if (g_pD3DDevice)
				g_pD3DDevice->SetRenderState(D3DRS_SHADEMODE, D3DSHADE_GOURAUD);
			break;
		}
		break;

	case WM_COMMAND:
		// Iꂽj[s
		switch (LOWORD(wParam))
		{
		case IDM_OPEN:	// Xt@CJ
			LoadXFile();
			break;

		case IDM_EXIT:	// vȌI
			DestroyWindow(hWnd);
			return 0;
		}
		break;
	}

	// ftHg
	return DefWindowProc(hWnd, msg, wParam, lParam);
}

/*--------------------------------------------
	ACh̏
--------------------------------------------*/
bool AppIdle(void)
{
	if (g_bD3DEmpty)
		return false;

	if (!g_bActive)
		return true;

	// foCX̕
	HRESULT hr;
	if (g_bDeviceLost)
	{
		Sleep(100);	// 0.1b҂

		// foCXԂ̃`FbN
		hr  = g_pD3DDevice->TestCooperativeLevel();
		if (FAILED(hr))
		{
			if (hr == D3DERR_DEVICELOST)
				return true;  // foCX͂܂Ă

			if (hr != D3DERR_DEVICENOTRESET)
				return false; // \ʃG[

			CleanupD3DObject(); // Direct3DŊǗĂȂ\[XJ
			hr = g_pD3DDevice->Reset(&g_D3DPP); // ݂
			if (FAILED(hr))
			{
				if (hr == D3DERR_DEVICELOST)
					return true; // foCX͂܂Ă

				DXTRACE_ERR("AppIdle Reset", hr);
				return false; // foCX̕Ɏs
			}
			hr = InitD3DObject();  // JDirect3DŊǗĂȂ\[XĎ擾
			if (FAILED(hr))
			{
				DXTRACE_ERR("AppIdle InitD3DObject", hr);
				return false;
			}
		}
		// foCX
		g_bDeviceLost = false;
	}

	// ʂ̍XV
	hr = Render();
	if (hr == D3DERR_DEVICELOST)
		g_bDeviceLost = true;	// foCX̏
	else if (FAILED(hr))
		return false;

	return true;
}

/*--------------------------------------------
	C
---------------------------------------------*/
int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpCmdLine, int nCmdShow)
{
	// AvP[VɊւ鏉
	HRESULT hr = InitApp(hInst);
	if (FAILED(hr))
	{
		DXTRACE_ERR("WinMain InitApp", hr);
		return 0;
	}

	// DirectX Graphics̏
	hr = InitDXGraphics();
	if (FAILED(hr))
		DXTRACE_ERR("WinMain InitDXGraphics", hr);
	else
	{
		// D3DɊǗȂIuWFNg̏
		hr = InitD3DObject();
		if (FAILED(hr))
		{
			DXTRACE_ERR("WinMain InitD3DObject", hr);
			DestroyWindow(g_hWindow);
		}
		else
			g_bD3DEmpty = false; // 
	}

	// bZ[WE[v
	MSG msg;
	do
	{
		if (PeekMessage(&msg, 0, 0, 0, PM_REMOVE))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		else
		{
			// ACh
			if (!AppIdle())
				// G[ꍇCAvP[VI
				DestroyWindow(g_hWindow);
		}
	} while (msg.message != WM_QUIT);

	// AvP[V̏I
	CleanupApp();

	return msg.wParam;
}

